#!/usr/local/bin/perl
# Program written by:
#
# Jens Heunemann
# Consol GmbH
#
# DATE 20.Jun.2000
# Version 1.00
#
# This program is protected by Copyright-law.
# Unauthorised use prohibited
# If you desire to use it, contact
# Consol GmbH
# in Munich, Germany
# Mail: jens@consol.de

BEGIN {
$0 =~ m!^(.*[\\/])?([^\\/]*)$!;
my $script=$2;
chdir $1 if $1;
}
use lib qw(.);
use Template;


=head1 beispiel

dies ist ein beispiel fr diverse verwendungen des template-moduls

verbesserungsvorschlge gern gesehen, das Template.pm-modul funktioniert zwar
einwandfrei, hat eber alle mglichen Ecken, wo es noch einfacher zu benutzen
sein knnte

=cut

my $t=Template->new; # neues Template-objekt erzeugen
my $t2=Template->new("example.tpl"); # gleich ein zweites objekt, welches schon mit dem inhalt eines files gefllt wird.

# mal ein beispieltemplate erzeugen
my $template=<<END;
Es gibt standalone-tags:
<!--perl: tag1-->
diese werden einfach durch einen entsprechenden wert ersetzt

und es gibt area-tags, die mit perlstart anfangen und mit perlend aufhren
der inhalt dazwischen wird an die entsprechende Unterroutine bergeben, die dann irgendwas beliebiges damit machen kann
<!--perlstart: tag2 para[a][b]dsfsd-->
a ist [a], b ist [b]
<!--perlend: tag2-->

ende des templates
END

# Nun den text ins template $t einbinden
$t->template($template);

#nun haben wir unser template, jetzt wollen wir die ausgabe haben
#ein einfaches beispiel, mit konstanten:
$a="$a enthlt 5";
%b=("a"=>10,"b"=>20);

$t->code("^tag1" => $a,
	 "^tag2" => \%b,
	);
# der code-methode werden regulre ausdrcke bergeben, die auf verschiedene
# werte verweisen. In diesem Beispiel werden skalare und eine hashreferenz
# verwendet. der skalar wird einfach eingesetzt.
# Die hashreferenz ist intern so implementiert, dass im inhalt zwischen dem
# perlstart und perlend nach [...] gesucht wird, hier [a] und [b] und die
# teile dann durch die entsprechenden werte des hashes ersetzt werden.

# um das Template jetzt auszugeben:
$t->print;


# so, nun ein etwas erweitertes beispiel, wo die interessanten sachen kommen.
# man kann bei code auch eine referenz auf eine unterroutine bergeben, die dann entsprechende Parameter bergeben kriegt.
# damit kann man dann natrlich beliebig viel schmarrn bauen :)

# $t2 ist schon von oben initialisiert
# fehlt nur noch der code

$t2->code(# das ist eine regular expression, also kann man es auch kurz machen, allerdings nicht so zu empfehlen
	  "^verzeichnis"=> # sucht im template nach allen perl-sektionen, die mit verzeichnis anfangen
	  sub {  # diese Zeile erzeugt eine anonyme unterroutine
	    # also eine Unterroutine, die keinen zugeordneten Namen hat

	    # bergebene Parameter sind:
	    # 1. Das template-objekt selbst
	    # 2. Der name des tags, hier also "verzeichnis"
	    # 3. der inhalt zwischen dem start und dem endtag

	    # bei reinen <!--perl: xxx par1 par2 par3--> tags ist parameter 3 der inhalt
	    # nach dem xxx
	    my $par=$_[2];
	    my $erg="<!-- objekt: $_[0] \n name: $_[1] \n -->";

	    opendir D,"/etc" or die $!;
	    while ($_=readdir D) {
	      last if $count++>5; # nur die ersten 6
	      my $tmp=$par; # temporre variable, in der wir was ndern knnen

	      $tmp=~s/\[name\]/$_/;
	      if (-f "/etc/$_") {
		$tmp=~s/\[typ\]/File/;
	      }
	      else {
		$tmp=~s/\[typ\]/kein File/;
	      }
	      $erg.=$tmp;
	    }
	    closedir D;
	    return $erg;
	  }, # komma ist hier wichtig!
	  "^blubb" => 1, # falls hier nmlich noch weitere werte kommen
	 ); # end of code

$t2->print;


# Noch eine andere Art, ein template aufzurufen

print "\n"x10;

$a={ "xyz" => 1,
     a=>10,
   };

$t3=Template->new(-type=>"simple",
		  -template=>"abc [xyz] [f]def [a]x blub",
		  -values=> $a,
		  );

#  $a->{xyz}=2;

#  $t3->values("xyz"=>3);

$t3->print;

